//----------------------------------------------------------------------------
// LightMenus.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: LightMenus.pas
//----------------------------------------------------------------------------
#ifndef LightMenusHPP
#define LightMenusHPP
//----------------------------------------------------------------------------
#include <Buttons.hpp>
#include <Forms.hpp>
#include <Messages.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Lightmenus
{
//-- type declarations -------------------------------------------------------
enum TSide { sdLeft, sdTop, sdRight, sdBottom };

typedef Set<TSide, sdLeft, sdBottom>  TSides;

enum TVerticalAlignment { vaTop, vaCenter, vaBottom };

class __declspec(delphiclass) TlmCustomPanel;
class __declspec(pascalimplementation) TlmCustomPanel : public Extctrls::TCustomPanel
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	bool FTrans;
	TVerticalAlignment FVerticalAlignment;
	bool FShowCaption;
	void __fastcall SetTrans(bool Value);
	void __fastcall SetShowCaption(bool Value);
	void __fastcall SetBevelSides(TSides Value);
	void __fastcall SetBorderColor(Graphics::TColor Value);
	void __fastcall SetBorderSides(TSides Value);
	void __fastcall SetVerticalAlignment(TVerticalAlignment Value);
	
protected:
	TSides FBevelSides;
	Graphics::TColor FBorderColor;
	TSides FBorderSides;
	void __fastcall DrawSides(const Windows::TRect &Rect, Graphics::TColor ULColor, Graphics::TColor LRColor
		, TSides Sides);
	void __fastcall DrawBevel(Windows::TRect &Rect, Graphics::TColor ULColor, Graphics::TColor LRColor, 
		int Width, TSides Sides);
	virtual Windows::TRect __fastcall GetClientRect(void);
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TlmCustomPanel(Classes::TComponent* AOwner);
	__property TSides BevelSides = {read=FBevelSides, write=SetBevelSides, default=15};
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=-2147483633
		};
	__property TSides BorderSides = {read=FBorderSides, write=SetBorderSides, nodefault};
	__property TVerticalAlignment VerticalAlignment = {read=FVerticalAlignment, write=SetVerticalAlignment
		, default=1};
	__property bool Transparent = {read=FTrans, write=SetTrans, nodefault};
	__property bool ShowCaption = {read=FShowCaption, write=SetShowCaption, nodefault};
public:
	/* TCustomControl.Destroy */ __fastcall virtual ~TlmCustomPanel(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TlmCustomPanel(HWND ParentWindow) : Extctrls::TCustomPanel(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TlmPanel;
class __declspec(pascalimplementation) TlmPanel : public TlmCustomPanel
{
	typedef TlmCustomPanel inherited;
	
__published:
	__property BevelSides ;
	__property BorderColor ;
	__property BorderSides ;
	__property VerticalAlignment ;
	__property Transparent ;
	__property ShowCaption ;
	__property Align ;
	__property Alignment ;
	__property BevelInner ;
	__property BevelOuter ;
	__property BevelWidth ;
	__property BorderStyle ;
	__property BorderWidth ;
	__property DragCursor ;
	__property Enabled ;
	__property Caption ;
	__property Color ;
	__property Ctl3D ;
	__property Font ;
	__property Locked ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnResize ;
public:
	/* TlmCustomPanel.Create */ __fastcall virtual TlmPanel(Classes::TComponent* AOwner) : Lightmenus::
		TlmCustomPanel(AOwner) { }
	
public:
	/* TCustomControl.Destroy */ __fastcall virtual ~TlmPanel(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TlmPanel(HWND ParentWindow) : Lightmenus::TlmCustomPanel(
		ParentWindow) { }
	
};

enum TTextStyle { tsNone, tsRaised, tsRecessed };

class __declspec(delphiclass) TlmLabel;
class __declspec(pascalimplementation) TlmLabel : public Stdctrls::TLabel
{
	typedef Stdctrls::TLabel inherited;
	
private:
	TTextStyle FTextStyle;
	Classes::TNotifyEvent FOnMouseEnter;
	Classes::TNotifyEvent FOnMouseLeave;
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Message);
	HIDESBASE void __fastcall DoDrawText(Windows::TRect &Rect, Word Flags);
	
protected:
	virtual void __fastcall Paint(void);
	void __fastcall SetTextStyle(TTextStyle Value);
	
public:
	__fastcall virtual TlmLabel(Classes::TComponent* AOwner);
	
__published:
	__property TTextStyle TextStyle = {read=FTextStyle, write=SetTextStyle, default=2};
	__property Classes::TNotifyEvent OnMouseEnter = {read=FOnMouseEnter, write=FOnMouseEnter};
	__property Classes::TNotifyEvent OnMouseLeave = {read=FOnMouseLeave, write=FOnMouseLeave};
public:
	/* TGraphicControl.Destroy */ __fastcall virtual ~TlmLabel(void) { }
	
};

enum TMenuStyle { msStandard, msOwnerDraw };

typedef void __fastcall (__closure *TMeasureMenuItem)(Menus::TMenuItem* MenuItem, int &Width, int &Height
	, Graphics::TCanvas* Canvas);

typedef void __fastcall (__closure *TDrawMenuItem)(Menus::TMenuItem* MenuItem, Graphics::TCanvas* Canvas
	, int ItemState, const Windows::TRect &ItemRect);

class __declspec(delphiclass) TlmCustomMenu;
class __declspec(pascalimplementation) TlmCustomMenu : public Menus::TMainMenu
{
	typedef Menus::TMainMenu inherited;
	
private:
	TMeasureMenuItem FMeasureItem;
	TDrawMenuItem FDrawItem;
	TMenuStyle FStyle;
	void *FPrevWndProc;
	void *FObjectInst;
	void __fastcall WndProc(Messages::TMessage &Msg);
	void __fastcall SetStyle(TMenuStyle Value);
	MESSAGE void __fastcall DrawItem(Messages::TWMDrawItem &Msg);
	MESSAGE void __fastcall MeasureItem(Messages::TWMMeasureItem &Msg);
	void __fastcall ModifyItems(Menus::TMenuItem* M, bool Std);
	void __fastcall SetMenuItem(Menus::TMenuItem* Value, bool Std);
	
protected:
	virtual void __fastcall DoDrawItem(Menus::TMenuItem* MenuItem, Graphics::TCanvas* Canvas, Cardinal 
		ItemState, const Windows::TRect &ItemRect);
	virtual void __fastcall DoMeasureItem(Menus::TMenuItem* MenuItem, int &Width, int &Height, Graphics::TCanvas* 
		Canvas);
	
public:
	__fastcall virtual TlmCustomMenu(Classes::TComponent* AOwner);
	__fastcall virtual ~TlmCustomMenu(void);
	virtual void __fastcall Loaded(void);
	__property TMenuStyle Style = {read=FStyle, write=SetStyle, nodefault};
	__property TDrawMenuItem OnDrawItem = {read=FDrawItem, write=FDrawItem};
	__property TMeasureMenuItem OnMeasureItem = {read=FMeasureItem, write=FMeasureItem};
};

class __declspec(delphiclass) TlmMenu;
class __declspec(pascalimplementation) TlmMenu : public TlmCustomMenu
{
	typedef TlmCustomMenu inherited;
	
__published:
	__property Style ;
	__property OnDrawItem ;
	__property OnMeasureItem ;
public:
	/* TlmCustomMenu.Create */ __fastcall virtual TlmMenu(Classes::TComponent* AOwner) : Lightmenus::TlmCustomMenu(
		AOwner) { }
	/* TlmCustomMenu.Destroy */ __fastcall virtual ~TlmMenu(void) { }
	
};

class __declspec(delphiclass) TlmCustomPopupMenu;
class __declspec(pascalimplementation) TlmCustomPopupMenu : public Menus::TPopupMenu
{
	typedef Menus::TPopupMenu inherited;
	
private:
	TMeasureMenuItem FMeasureItem;
	TDrawMenuItem FDrawItem;
	TMenuStyle FStyle;
	void *FPrevWndProc;
	void *FObjectInst;
	void __fastcall WndProc(Messages::TMessage &Mssg);
	void __fastcall SetStyle(TMenuStyle Value);
	MESSAGE void __fastcall DrawItem(Messages::TWMDrawItem &Msg);
	MESSAGE void __fastcall MeasureItem(Messages::TWMMeasureItem &Msg);
	void __fastcall ModifyItems(Menus::TMenuItem* M, bool Std);
	void __fastcall SetMenuItem(Menus::TMenuItem* Value, bool Std);
	
protected:
	virtual void __fastcall DoDrawItem(Menus::TMenuItem* MenuItem, Graphics::TCanvas* Canvas, Cardinal 
		ItemState, const Windows::TRect &ItemRect);
	virtual void __fastcall DoMeasureItem(Menus::TMenuItem* MenuItem, int &Width, int &Height, Graphics::TCanvas* 
		Canvas);
	virtual void __fastcall Popup(int X, int Y);
	
public:
	__fastcall virtual TlmCustomPopupMenu(Classes::TComponent* AOwner);
	__fastcall virtual ~TlmCustomPopupMenu(void);
	virtual void __fastcall Loaded(void);
	__property TMenuStyle Style = {read=FStyle, write=SetStyle, nodefault};
	__property TDrawMenuItem OnDrawItem = {read=FDrawItem, write=FDrawItem};
	__property TMeasureMenuItem OnMeasureItem = {read=FMeasureItem, write=FMeasureItem};
};

class __declspec(delphiclass) TlmPopupMenu;
class __declspec(pascalimplementation) TlmPopupMenu : public TlmCustomPopupMenu
{
	typedef TlmCustomPopupMenu inherited;
	
__published:
	__property Style ;
	__property OnDrawItem ;
	__property OnMeasureItem ;
public:
	/* TlmCustomPopupMenu.Create */ __fastcall virtual TlmPopupMenu(Classes::TComponent* AOwner) : Lightmenus::
		TlmCustomPopupMenu(AOwner) { }
	/* TlmCustomPopupMenu.Destroy */ __fastcall virtual ~TlmPopupMenu(void) { }
	
};

typedef void __fastcall (__closure *TOnClickFolder)(System::TObject* Sender,  System::AnsiString Folder
	);

class __declspec(delphiclass) TlmFolderMenu;
class __declspec(pascalimplementation) TlmFolderMenu : public TlmCustomPopupMenu
{
	typedef TlmCustomPopupMenu inherited;
	
private:
	System::AnsiString FFolder;
	bool FNoSubFolder;
	bool FShowFiles;
	Controls::TImageList* FBitmaps;
	TOnClickFolder FOnClickFolder;
	bool FSmallIcon;
	int FImageSize;
	virtual void __fastcall DoDrawItem(Menus::TMenuItem* MenuItem, Graphics::TCanvas* Canvas, Cardinal 
		ItemState, const Windows::TRect &ItemRect);
	virtual void __fastcall DoMeasureItem(Menus::TMenuItem* MenuItem, int &Width, int &Height, Graphics::TCanvas* 
		Canvas);
	Graphics::TIcon* __fastcall GetFileIcon( System::AnsiString FileName);
	void __fastcall MakeMenu( System::AnsiString Path, Menus::TMenuItem* Items);
	void __fastcall DoClickFolder(System::TObject* Sender);
	
public:
	__fastcall virtual TlmFolderMenu(Classes::TComponent* AOwner);
	__fastcall virtual ~TlmFolderMenu(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Popup(int X, int Y);
	
__published:
	__property System::AnsiString Folder = {read=FFolder, write=FFolder, nodefault};
	__property bool NoSubFolder = {read=FNoSubFolder, write=FNoSubFolder, nodefault};
	__property bool ShowFiles = {read=FShowFiles, write=FShowFiles, nodefault};
	__property bool SmallIcon = {read=FSmallIcon, write=FSmallIcon, nodefault};
	__property TOnClickFolder OnClickFolder = {read=FOnClickFolder, write=FOnClickFolder};
};

//-- var, const, procedure ---------------------------------------------------
#define msSelected (Byte)(1)
#define msChecked (Byte)(8)
#define msGrayed (Byte)(2)
#define msDefault (Byte)(32)
extern Graphics::TColor ULBevelColor[3];
extern Graphics::TColor LRBevelColor[3];
extern Word TextAlignments[3];
extern void __fastcall Register(void);
extern void __fastcall MsgText( System::AnsiString AText);
extern void __fastcall MsgError( System::AnsiString AText);
extern void __fastcall MsgStop( System::AnsiString AText);
extern void __fastcall MsgWarning( System::AnsiString AText);
extern int __fastcall MsgYesNo( System::AnsiString AText);
extern int __fastcall MsgOkCancel( System::AnsiString AText);
extern int __fastcall MsgYesNoCancel( System::AnsiString AText);
extern bool __fastcall PointInRect(const tagPOINT &P, const Windows::TRect &R);
//-- template instantiations -------------------------------------------------
template class TSides ;

}	/* namespace Lightmenus */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Lightmenus;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// LightMenus
